#ifndef MAINDIALOGIMPL_H
#define MAINDIALOGIMPL_H
#include "maindialog.h"

#include <qfiledialog.h>
#include <qmessagebox.h>
#include <qimage.h>
#include <qlabel.h>
#include <qtextview.h>
#include <qpicture.h>
#include <qvbox.h>
#include <qbuttongroup.h>
#include <qcheckbox.h>
#include <qtabwidget.h>
#include <qlcdnumber.h>
#include <qbutton.h>
#include <qpushbutton.h>
#include <qlistview.h>
#include <qcolordialog.h>
#include <qlineedit.h>
#include <qradiobutton.h>


// MENUS
#include <qmainwindow.h>
#include <qaction.h>
#include <qpopupmenu.h>
#include <qmenubar.h>
#include <qapplication.h>
#include <qmessagebox.h>
#include <qstatusbar.h>		// barre d'etat

// STYLES
#include <qmotifstyle.h>
#include <qmotifplusstyle.h>
#include <qcdestyle.h>
#include <qwindowsstyle.h>
#include <qplatinumstyle.h>
#include <qsgistyle.h>
#include <qfont.h>


// Presse papier
#include <qclipboard.h>
#include <qdragobject.h>

// STDLIBs
#include <stdio.h>

// QMainWindow pour MENUS
class maindialogImpl : public mainDialogBase
{ 
    Q_OBJECT

public:
    maindialogImpl( QWidget* parent = 0, const char* name = 0, bool modal = FALSE, WFlags fl = 0 );
    ~maindialogImpl();
	bool fileExists(QFile fileOut, QString file);
	void setDialogStatusBar(QStatusBar *status);

public slots://protected
    void loadBinClick();
    void previousClick();
    void nextClick();
    void loadBmpClick();
    void saveBinClick();
    void saveBmpClick();
    void tabChanged();
    void itemClick(int,QListViewItem*,const QPoint&,int);
    void colorClick();
    void exportChanged(int);
	 void exportClick();
    void menuCopyBmp();
    void menuCopyBin();
    void exportCopieClick();

private slots:

private:
	int _nbImage;
	char _data[1024*32];		// buffer images
	QColor _color;
	
	void drawImage(int i = 0);
	void displayBinary(int i);

	void exportAscii(QString &str);

	QStatusBar *statusbar;
	QClipboard *cb;
};



class MyPreview : public QWidget, public QFilePreview
{
	public:
		MyPreview() : QWidget(), QFilePreview() {}
		// reimplementation from QFilePreview
		void previewUrl( const QUrl &url ) {
			QImageIO imageio;
			QPixmap  pixmap;
			imageio.setFileName(url.fileName() );
			QString str;
			str.sprintf("fileprev %s ?? ", url.fileName());
			QMessageBox::information( this, tr( "Message" ), tr(str) );
	
			QPainter p( this );
        p.setPen( Qt::blue );
        p.drawText( rect(), AlignCenter, "The Text" );
			if ( imageio.read() )  pixmap = imageio.image();  // ok -> convert to pixmap
//void QPainter::drawPixmap ( const QPoint & p, const QPixmap & pm )

//void QPainter::drawPixmap ( const QPoint & p, const QPixmap & pm, const QRect & sr )
			QPoint *pt = new QPoint(10, 10);
			p.drawPixmap( *pt, pixmap);
			//p.drawThePreviewOfUrl();
			p.end();
//	fd.addRightWidget(preview);//QWidget * w ); 
			delete pt;
		}
};


#endif // MAINDIALOGIMPL_H
